<?php
//
//
// Converting for Fireboard by joomlaweb.com
//
//
//
// Copyright (C) 2006 Rowan Seymour
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// The "GNU General Public License" (GPL) is available at
// http://www.gnu.org/copyleft/gpl.html.
//
// mod_birthdays is free software and parts of it are derived from
// GNU GPL CbBirthday 1.0 Beta by Erik Happaerts
//
//
//
//
//

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// Required for time offset variables
require('configuration.php');

// Load module parameters
$layout_type = $params->get('layout_type');
$time_offset = $params->get('time_offset');

$dob_field = $params->get('dob_field');
$hideage_field = $params->get('hideage_field');
$max_birthdays = $params->get('max_birthdays');
$max_daysaway = $params->get('max_daysaway');

$name_link = $params->get('name_link');
$reminder_format = $params->get('reminder_format');
$tomorrow_format = $params->get('tomorrow_format');
$today_format = $params->get('today_format');
$tooltip_format = $params->get('tooltip_format');
$date_format = $params->get('bdaydate_format');
$none_text = $params->get('none_text');

// Run module main method
birthdays_main($layout_type, $time_offset, $dob_field, $hideage_field, $max_birthdays, $max_daysaway, $name_link, $reminder_format, $today_format, $tomorrow_format, $tooltip_format, $date_format, $none_text);

// Module main method
//
function birthdays_main($layout_type, $time_offset, $dob_field, $hideage_field, $max_birthdays, $max_daysaway, $name_link, $reminder_format, $today_format, $tomorrow_format, $tooltip_format, $date_format, $none_text)
{
	global $database, $mosConfig_offset_user;
	
	// Check for existence of D.O.B field
	$database->setQuery("SHOW COLUMNS FROM #__fb_users LIKE '$dob_field'");
	if ($database->loadObjectList() == null) {
		echo "Error: Specified D.O.B field is not an existing CB profile field.\n";
		return;
	}
	
	// Calculate reference "now" date
	if ($time_offset == 0) // Website
		$refdate = gmdate('Ymd', time() + (60 * 60 * $mosConfig_offset_user));
	else if ($time_offset == 1) // Server
		$refdate = date('Ymd');		
	else // GMT
		$reftime = gmdate('Ymd');
		
	// Load birthdays 
	$birthdays = birthdays_load($refdate, $dob_field, $hideage_field, $max_birthdays, $max_daysaway);
	if ($birthdays == null) {
		echo $none_text;
		return;
	}
	
	// Generate formatted items
	$items = array();
	foreach ($birthdays as $birthday)
		$items[] = birthdays_makeitem($birthday, $name_link, $reminder_format, $today_format, $tomorrow_format, $tooltip_format, $date_format, $refdate);
	
	// Generate item layout
	$content = "";	
	if ($layout_type == 0) {
		$content .= "<ul>\n";
		foreach ($items as $item)
			$content .= '<li>'.$item."</li>\n";
		$content .= "</ul>\n";
	}
	else {
		$content .= "<table border=\"0\">\n";
		foreach ($items as $item)
			$content .= '<tr><td>'.$item."</td></tr>\n";
		$content .= "</table>\n";		
	}
		
	echo $content;
}

// Loads the birthdays from the CB profile table
//
function birthdays_load($refdate, $dob_field, $hideage_field, $max_birthdays, $max_daysaway)
{
	global $database;
	
	// Date of person's birthday this year
	$sqlbday0 = "CONCAT(YEAR($refdate), '-', MONTH(b.$dob_field), '-', DAYOFMONTH(b.$dob_field))";
	// Date of person's birthday next year
	$sqlbday1 = "CONCAT(YEAR($refdate) + 1, '-', MONTH(b.$dob_field), '-', DAYOFMONTH(b.$dob_field))";
	// Days to person's bithday this year
	$sqldays0 = "(TO_DAYS($sqlbday0) - TO_DAYS($refdate))";
	// Days to person's bithday next year
	$sqldays1 = "(TO_DAYS($sqlbday1) - TO_DAYS($refdate))";

	$sqlselect = "SELECT a.id, a.username, a.name, YEAR(b.$dob_field) AS dobyear, MONTH(b.$dob_field) AS dobmonth, DAYOFMONTH(b.$dob_field) AS dobday, $sqldays0 AS daysaway0, $sqldays1 AS daysaway1";
	$sqlfrom = "FROM #__users AS a, #__fb_users AS b ";
	$sqlwhere	= "WHERE (a.id = b.userid) AND YEAR(b.$dob_field)>1900  AND ((($sqldays0 >= 0) AND ($sqldays0 <= $max_daysaway)) OR ($sqldays1 <= $max_daysaway))";
	$sqlorderby = "ORDER BY daysaway1 ASC ";		
	$sqllimit = "LIMIT $max_birthdays;";
	
	// If the hide-age field has been specified, read it, else assume false
	if (trim($hideage_field) == '')
		$sqlselect .= ", 0 AS hideage";
	else
		$sqlselect .= ", b.$hideage_field AS hideage";		

	$database->setQuery("$sqlselect $sqlfrom $sqlwhere $sqlorderby $sqllimit");
	
	//echo "$sqlselect $sqlfrom $sqlwhere $sqlorderby $sqllimit";
  return $database->loadObjectList();
}

// Creates an item in the birthday list
//
function birthdays_makeitem($birthday, $name_link, $reminder_format, $today_format, $tomorrow_format, $tooltip_format, $date_format, $refdate)
{
	// Get the current year from the reference date (YYYYMMDD)
	$curyear = floor($refdate / 10000);
	
	// Calculate days until birthday and age
	$isnextyear = ($birthday->daysaway0 < 0);
	$days = $isnextyear ? $birthday->daysaway1 : $birthday->daysaway0;
	$daydate = strftime($date_format, mktime(0, 0, 0, $birthday->dobmonth, $birthday->dobday, $isnextyear ? $curyear : ($curyear + 1)));
	
	// Optionally hide age
	if ($birthday->hideage)
		$age = "?";
	else
		$age = ($isnextyear ? ($curyear + 1) : $curyear) - $birthday->dobyear;
	
	// Create name/username link url
	$name_linkurl = '';	
	switch ($name_link) {
		case 1:
			$name_linkurl = "index.php?option=com_kunena&amp;func=fbprofile&amp;task=showprf&amp;userid=".$birthday->id;
			break;
		case 2:
			$name_linkurl = "index.php?option=com_mypms&task=new&to=".$birthday->username;
			break;
		case 3:
			$name_linkurl = "index.php?option=com_uddeim&task=new&recip=".$birthday->id;
			break;
		case 4:
			$name_linkurl = "index.php?option=com_comprofiler&amp;task=userProfile&amp;user=".$birthday->id;
			break;
	}

	// Select format of reminder
	$format = $reminder_format;
	if ($days == 0)
		$format = $today_format;
	else if ($days == 1)
		$format = $tomorrow_format;

	$format = str_replace("%U", ($name_linkurl != '') ? ("<a href=\"".$name_linkurl."\">".$birthday->username."</a>") : ($birthday->username), $format);	
	$format = str_replace("%N", ($name_linkurl != '') ? ("<a href=\"".$name_linkurl."\">".$birthday->name."</a>") : ($birthday->name), $format);
	$format = str_replace("%A", $age, $format);
	$format = str_replace("%D", $days, $format);
	$format = str_replace("%B", $daydate, $format);

	$tooltip = $tooltip_format;
	$tooltip = str_replace("%U", $birthday->username, $tooltip);	
	$tooltip = str_replace("%N", $birthday->name, $tooltip);
	$tooltip = str_replace("%A", $age, $tooltip);
	$tooltip = str_replace("%D", $days, $tooltip);
	$tooltip = str_replace("%B", $daydate, $tooltip);

	return ($tooltip != '') ? ("<span title=\"".$tooltip."\">".$format."</span>") : $format;
}

?>
